version: "3"
services:
  redis:
    image: redis:6.2-alpine3.13
    networks:
      - redis-net

  db:
    image: postgres:13.2-alpine
    environment:
      POSTGRES_USER: "postgres"
      POSTGRES_PASSWORD: "postgres"
    networks:
      - postgres-net

  vote:
    image: registry.gitlab.com/voting-application/vote:v1
    ports:
      - 5000:80
    networks:
      - redis-net
    depends_on:
      - redis

  result:
    image: registry.gitlab.com/voting-application/result:v1
    ports:
      - 5001:80
    networks:
      - postgres-net

  worker:
    image: registry.gitlab.com/voting-application/worker:dotnet
    networks:
      - redis-net
      - postgres-net
    depends_on:
      - db
      - redis

  visualizer:
    image: dockersamples/visualizer:stable
    ports:
      - "8080:8080"
    volumes:
      - "/var/run/docker.sock:/var/run/docker.sock"

networks:
  redis-net:
    driver: overlay
  postgres-net:
    driver: overlay
